function out = Plassoncomplete
out{1} = @init;
out{2} = @fun_eval;
out{3} = @jacobian;
out{4} = @jacobianp;
out{5} = @hessians;
out{6} = @hessiansp;
out{7} = @der3;
out{8} = [];
out{9} = [];

% --------------------------------------------------------------------------
function dydt = fun_eval(t,kmrgd,a,p,alpha,h,e,cc,b,beta,gamma)
LD=0.5*(cc-kmrgd(1)-kmrgd(3)-kmrgd(2)-kmrgd(4)-2*kmrgd(5)-2*kmrgd(7)-2*kmrgd(6));
dydt=[-a*kmrgd(1)-p*kmrgd(1)*kmrgd(3)-alpha*p*kmrgd(4)*kmrgd(1)+2*h*kmrgd(5)+b*kmrgd(3)+beta*h*kmrgd(6)+beta*h*LD;
-a*kmrgd(2)-p*kmrgd(2)*kmrgd(4)-alpha*p*kmrgd(3)*kmrgd(2)+2*h*kmrgd(7)+b*kmrgd(4)+beta*h*kmrgd(6)+beta*h*LD;
a*kmrgd(1)-p*kmrgd(1)*kmrgd(3)-alpha*p*kmrgd(3)*kmrgd(2)-b*kmrgd(3);
a*kmrgd(2)-p*kmrgd(2)*kmrgd(4)-alpha*p*kmrgd(4)*kmrgd(1)-b*kmrgd(4);
p*kmrgd(1)*kmrgd(3)-h*kmrgd(5)+e*kmrgd(6)-gamma*e*kmrgd(5);
alpha*p*kmrgd(1)*kmrgd(4)-e*kmrgd(6)-beta*h*kmrgd(6)+gamma*e*kmrgd(5);
p*kmrgd(2)*kmrgd(4)-h*kmrgd(7)+e*LD-gamma*e*kmrgd(7);];

% --------------------------------------------------------------------------
function [tspan,y0,options] = init
handles = feval(Plassoncomplete);
y0=[0,0,0,0,0,0,0];
options = odeset('Jacobian',handles(3),'JacobianP',handles(4),'Hessians',handles(5),'HessiansP',handles(6));
tspan = [0 10];

% --------------------------------------------------------------------------
function jac = jacobian(t,kmrgd,a,p,alpha,h,e,cc,b,beta,gamma)
jac=[ - a - kmrgd(3)*p - (beta*h)/2 - kmrgd(4)*alpha*p , -(beta*h)/2 , b - kmrgd(1)*p - (beta*h)/2 , - (beta*h)/2 - kmrgd(1)*alpha*p , 2*h - beta*h , 0 , -beta*h ; -(beta*h)/2 , - a - kmrgd(4)*p - (beta*h)/2 - kmrgd(3)*alpha*p , - (beta*h)/2 - kmrgd(2)*alpha*p , b - kmrgd(2)*p - (beta*h)/2 , -beta*h , 0 , 2*h - beta*h ; a - kmrgd(3)*p , -kmrgd(3)*alpha*p , - b - kmrgd(1)*p - kmrgd(2)*alpha*p , 0 , 0 , 0 , 0 ; -kmrgd(4)*alpha*p , a - kmrgd(4)*p , 0 , - b - kmrgd(2)*p - kmrgd(1)*alpha*p , 0 , 0 , 0 ; kmrgd(3)*p , 0 , kmrgd(1)*p , 0 , - h - e*gamma , e , 0 ; kmrgd(4)*alpha*p , 0 , 0 , kmrgd(1)*alpha*p , e*gamma , - e - beta*h , 0 ; -e/2 , kmrgd(4)*p - e/2 , -e/2 , kmrgd(2)*p - e/2 , -e , -e , - e - h - e*gamma ];
% --------------------------------------------------------------------------
function jacp = jacobianp(t,kmrgd,a,p,alpha,h,e,cc,b,beta,gamma)
jacp=[ -kmrgd(1) , - kmrgd(1)*kmrgd(3) - kmrgd(4)*kmrgd(1)*alpha , -kmrgd(4)*kmrgd(1)*p , 2*kmrgd(5) + kmrgd(6)*beta - beta*(kmrgd(7) + kmrgd(6) + kmrgd(2)/2 + kmrgd(4)/2 + kmrgd(1)/2 + kmrgd(5) + kmrgd(3)/2 - cc/2) , 0 , (beta*h)/2 , kmrgd(3) , kmrgd(6)*h - h*(kmrgd(7) + kmrgd(6) + kmrgd(2)/2 + kmrgd(4)/2 + kmrgd(1)/2 + kmrgd(5) + kmrgd(3)/2 - cc/2) , 0 ; -kmrgd(2) , - kmrgd(2)*kmrgd(4) - kmrgd(2)*kmrgd(3)*alpha , -kmrgd(2)*kmrgd(3)*p , 2*kmrgd(7) + kmrgd(6)*beta - beta*(kmrgd(7) + kmrgd(6) + kmrgd(2)/2 + kmrgd(4)/2 + kmrgd(1)/2 + kmrgd(5) + kmrgd(3)/2 - cc/2) , 0 , (beta*h)/2 , kmrgd(4) , kmrgd(6)*h - h*(kmrgd(7) + kmrgd(6) + kmrgd(2)/2 + kmrgd(4)/2 + kmrgd(1)/2 + kmrgd(5) + kmrgd(3)/2 - cc/2) , 0 ; kmrgd(1) , - kmrgd(1)*kmrgd(3) - kmrgd(2)*kmrgd(3)*alpha , -kmrgd(2)*kmrgd(3)*p , 0 , 0 , 0 , -kmrgd(3) , 0 , 0 ; kmrgd(2) , - kmrgd(2)*kmrgd(4) - kmrgd(4)*kmrgd(1)*alpha , -kmrgd(4)*kmrgd(1)*p , 0 , 0 , 0 , -kmrgd(4) , 0 , 0 ; 0 , kmrgd(1)*kmrgd(3) , 0 , -kmrgd(5) , kmrgd(6) - kmrgd(5)*gamma , 0 , 0 , 0 , -kmrgd(5)*e ; 0 , kmrgd(4)*kmrgd(1)*alpha , kmrgd(4)*kmrgd(1)*p , -kmrgd(6)*beta , kmrgd(5)*gamma - kmrgd(6) , 0 , 0 , -kmrgd(6)*h , kmrgd(5)*e ; 0 , kmrgd(2)*kmrgd(4) , 0 , -kmrgd(7) , cc/2 - kmrgd(6) - kmrgd(2)/2 - kmrgd(4)/2 - kmrgd(1)/2 - kmrgd(5) - kmrgd(3)/2 - kmrgd(7) - kmrgd(7)*gamma , e/2 , 0 , 0 , -kmrgd(7)*e ];
% --------------------------------------------------------------------------
function hess = hessians(t,kmrgd,a,p,alpha,h,e,cc,b,beta,gamma)
hess1=[ 0 , 0 , -p , -alpha*p , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , -p , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , -alpha*p , 0 , 0 , 0 ; 0 , 0 , p , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , alpha*p , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess2=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , -alpha*p , -p , 0 , 0 , 0 ; 0 , 0 , -alpha*p , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , -p , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , p , 0 , 0 , 0 ];
hess3=[ -p , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , -alpha*p , 0 , 0 , 0 , 0 , 0 ; -p , -alpha*p , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; p , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess4=[ -alpha*p , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , -p , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; -alpha*p , -p , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; alpha*p , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , p , 0 , 0 , 0 , 0 , 0 ];
hess5=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess6=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess7=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess(:,:,1) =hess1;
hess(:,:,2) =hess2;
hess(:,:,3) =hess3;
hess(:,:,4) =hess4;
hess(:,:,5) =hess5;
hess(:,:,6) =hess6;
hess(:,:,7) =hess7;
% --------------------------------------------------------------------------
function hessp = hessiansp(t,kmrgd,a,p,alpha,h,e,cc,b,beta,gamma)
hessp1=[ -1 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , -1 , 0 , 0 , 0 , 0 , 0 ; 1 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 1 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp2=[ - kmrgd(3) - kmrgd(4)*alpha , 0 , -kmrgd(1) , -kmrgd(1)*alpha , 0 , 0 , 0 ; 0 , - kmrgd(4) - kmrgd(3)*alpha , -kmrgd(2)*alpha , -kmrgd(2) , 0 , 0 , 0 ; -kmrgd(3) , -kmrgd(3)*alpha , - kmrgd(1) - kmrgd(2)*alpha , 0 , 0 , 0 , 0 ; -kmrgd(4)*alpha , -kmrgd(4) , 0 , - kmrgd(2) - kmrgd(1)*alpha , 0 , 0 , 0 ; kmrgd(3) , 0 , kmrgd(1) , 0 , 0 , 0 , 0 ; kmrgd(4)*alpha , 0 , 0 , kmrgd(1)*alpha , 0 , 0 , 0 ; 0 , kmrgd(4) , 0 , kmrgd(2) , 0 , 0 , 0 ];
hessp3=[ -kmrgd(4)*p , 0 , 0 , -kmrgd(1)*p , 0 , 0 , 0 ; 0 , -kmrgd(3)*p , -kmrgd(2)*p , 0 , 0 , 0 , 0 ; 0 , -kmrgd(3)*p , -kmrgd(2)*p , 0 , 0 , 0 , 0 ; -kmrgd(4)*p , 0 , 0 , -kmrgd(1)*p , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; kmrgd(4)*p , 0 , 0 , kmrgd(1)*p , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp4=[ -beta/2 , -beta/2 , -beta/2 , -beta/2 , 2 - beta , 0 , -beta ; -beta/2 , -beta/2 , -beta/2 , -beta/2 , -beta , 0 , 2 - beta ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , -1 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , -beta , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , -1 ];
hessp5=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , -gamma , 1 , 0 ; 0 , 0 , 0 , 0 , gamma , -1 , 0 ; -1/2 , -1/2 , -1/2 , -1/2 , -1 , -1 , - gamma - 1 ];
hessp6=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp7=[ 0 , 0 , 1 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 1 , 0 , 0 , 0 ; 0 , 0 , -1 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , -1 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp8=[ -h/2 , -h/2 , -h/2 , -h/2 , -h , 0 , -h ; -h/2 , -h/2 , -h/2 , -h/2 , -h , 0 , -h ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , -h , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp9=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , -e , 0 , 0 ; 0 , 0 , 0 , 0 , e , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , -e ];
hessp(:,:,1) =hessp1;
hessp(:,:,2) =hessp2;
hessp(:,:,3) =hessp3;
hessp(:,:,4) =hessp4;
hessp(:,:,5) =hessp5;
hessp(:,:,6) =hessp6;
hessp(:,:,7) =hessp7;
hessp(:,:,8) =hessp8;
hessp(:,:,9) =hessp9;
%---------------------------------------------------------------------------
function tens3  = der3(t,kmrgd,a,p,alpha,h,e,cc,b,beta,gamma)
tens31=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens32=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens33=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens34=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens35=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens36=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens37=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens38=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens39=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens310=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens311=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens312=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens313=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens314=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens315=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens316=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens317=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens318=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens319=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens320=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens321=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens322=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens323=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens324=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens325=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens326=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens327=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens328=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens329=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens330=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens331=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens332=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens333=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens334=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens335=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens336=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens337=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens338=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens339=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens340=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens341=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens342=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens343=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens344=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens345=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens346=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens347=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens348=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens349=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
tens3(:,:,1,1) =tens31;
tens3(:,:,1,2) =tens32;
tens3(:,:,1,3) =tens33;
tens3(:,:,1,4) =tens34;
tens3(:,:,1,5) =tens35;
tens3(:,:,1,6) =tens36;
tens3(:,:,1,7) =tens37;
tens3(:,:,2,1) =tens38;
tens3(:,:,2,2) =tens39;
tens3(:,:,2,3) =tens310;
tens3(:,:,2,4) =tens311;
tens3(:,:,2,5) =tens312;
tens3(:,:,2,6) =tens313;
tens3(:,:,2,7) =tens314;
tens3(:,:,3,1) =tens315;
tens3(:,:,3,2) =tens316;
tens3(:,:,3,3) =tens317;
tens3(:,:,3,4) =tens318;
tens3(:,:,3,5) =tens319;
tens3(:,:,3,6) =tens320;
tens3(:,:,3,7) =tens321;
tens3(:,:,4,1) =tens322;
tens3(:,:,4,2) =tens323;
tens3(:,:,4,3) =tens324;
tens3(:,:,4,4) =tens325;
tens3(:,:,4,5) =tens326;
tens3(:,:,4,6) =tens327;
tens3(:,:,4,7) =tens328;
tens3(:,:,5,1) =tens329;
tens3(:,:,5,2) =tens330;
tens3(:,:,5,3) =tens331;
tens3(:,:,5,4) =tens332;
tens3(:,:,5,5) =tens333;
tens3(:,:,5,6) =tens334;
tens3(:,:,5,7) =tens335;
tens3(:,:,6,1) =tens336;
tens3(:,:,6,2) =tens337;
tens3(:,:,6,3) =tens338;
tens3(:,:,6,4) =tens339;
tens3(:,:,6,5) =tens340;
tens3(:,:,6,6) =tens341;
tens3(:,:,6,7) =tens342;
tens3(:,:,7,1) =tens343;
tens3(:,:,7,2) =tens344;
tens3(:,:,7,3) =tens345;
tens3(:,:,7,4) =tens346;
tens3(:,:,7,5) =tens347;
tens3(:,:,7,6) =tens348;
tens3(:,:,7,7) =tens349;
%---------------------------------------------------------------------------
function tens4  = der4(t,kmrgd,a,p,alpha,h,e,cc,b,beta,gamma)
%---------------------------------------------------------------------------
function tens5  = der5(t,kmrgd,a,p,alpha,h,e,cc,b,beta,gamma)
